// Copyright (C) 2008 Universitaet Karlsruhe, Germany
//
// This source is protected by the GNU General Public License. 
//

package de.uka.iti.lights;

import java.io.IOException;

/**
 * <p>This is a general example how to use {@link Lights}.</p>
 * 
 * <p>Please consult the source code ... </p> 
 * 
 * @author Mattias Ulbrich
 * @version 2008.1
 */

public class Example {

	/**
	 * solve a Light Up puzzle. <p> Consult the source code </p> 
	 */
	public void solve(String desc) throws LightsFormatException, IOException, InterruptedException {
		
		Lights lights = new Lights(desc);
		
		// if you want:
		// lights.showWindow();
		
		// 1. write the clauses to a file "in.minisat"
		//    using the methods of object "lights"
		
		// . . . 
		
		// 2. call minisat
		// This will fail if minisat is not in the path
		Process p = Runtime.getRuntime().exec("minisat in.minisat out.minisat");
		p.waitFor();
		
		// 3. interpret output
		// Open file "out.minisat", interpret the lines
		// and set the lights in "lights" accordingly
		
		// 4. output result
		lights.showWindow();
		
		System.out.println("If the solution is correct: submit this string:");
		System.out.println(lights.toString());
	}

}
